#include <inttypes.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

uint64_t nano_count()
{
  struct timespec t;
  int ret;
  ret = clock_gettime(CLOCK_MONOTONIC,&t);
  if(ret != 0) {
    fprintf(stderr, "clock_gettime failed\n");
    exit(2);
  }
  return (uint64_t) t.tv_sec * 1000000000 + t.tv_nsec;
}

int
main()
{
  uint64_t old_nanos = 0;
  for (;;) {
    uint64_t nanos = nano_count();
    if (nanos <= old_nanos) {
      fprintf(stderr, "!!! Clock is not monotonic: %lu >= %lu\n", old_nanos,
nanos);
      exit(1);
    }
    old_nanos = nanos;
  }
}


